function Chnl()
{
   this.ch;
   this.ct;
   this.am;
   this.ts;
   this.lb;
   this.cn0;
   this.cr;
   this.st;
   this.mm;
}
function Sat()
{
   this.prn;
   this.az;
   this.el;
   this.chnl = [];
}

var GPSIDX =
{
   L1CA   :0,
   L1P1   :1,
   L2P    :2,
   L2C    :3,
   L2     :3,
   L2CL   :4,
   L5     :5,
   L5Q    :5
};

var SBASIDX =
{
   L1CA   :0,
   L1P1   :1,
   L2     :2,
   L2C    :3,
   L5     :4
};

var GALIDX =
{
   E1B    :0,
   E5AI   :1,
   E5AQ   :2,
   E5BQ   :3
};

var BEIIDX =
{
   B1I    :0,
   B1Q    :1,
   B2I    :2,
   B2Q    :3
};

var GLNIDX =
{
   G1C    :0,
   G2C    :1,
   G1P    :2,
   G2P    :3
};

var XCODE =
{                    // list of supported codes (code-less) and frequencies 
   CW_L1       : 0,  // codeless L1
   CW_L2       : 1,  // codeless L2
   CW_L5       : 2,  // codeless L5
   CA_L1       : 3,  // C/A on L1
   CA_L2       : 4,  // C/A on L2
   L2CM        : 5,  // L2C medium code
   L2CL        : 6,  // L2C long code
   L5I         : 7,  // L5 I code
   L5Q         : 8,  // L5 Q code
   MEM_CODE_4  : 9,  // 4*1023 bit Memory code
   MEM_CODE_5  :10,  // 5*1023 bit Memory code
   P_L1        :11,  // clear P on L1
   P_L2        :12,  // clear P on L2
   Y_L1        :13,  // P(Y) and C/A on L1 P channel
   Y_L2Acq     :14,  // P(Y) acqisition on L2 x L1 on Y channel
   Y_L1Acq     :15,  // P(Y) acqisition on L1 x L1 on Y channel
   Y_L2Trk     :16,  // P(Y) Tracking on L2 x L1 on Y channel
   Y_L1Trk     :17,  // P(Y) Tracking on L1 x L1 on Y channel
   E5AI        :18,  // Galileo E5A I code (data messages)
   E5AQ        :19,  // Galileo E5A Q code (no data messages)
   E5BI        :20,  // Galileo E5B I code (data messages)
   E5BQ        :21,  // Galileo E5B Q code (no data messages)
   E1B         :22,  // Galileo E1 B code (data messages)
   E1C         :23,  // Galileo E1 C code (no data messages)
   E6B         :24,  // Galileo E6 B code (data messages)
   E6C         :25,  // Galileo E6 C code (no data messages)
   G1C         :26,  // BCG - GLONASS Civil G1 code (data messages)
   G2C         :27,  // BCG - GLONASS Civil G2 code (no data messages)
   G1P         :28,  // 28 WY  - GLONASS Military G1 Code
   G2P         :29,  // 29 WY  - GLONASS Military G2 Code
   // sphinx
   L1CD        :30,  // 30 WY  - L1C BOC(11)+BOC(61) for data channel
   L1CP        :31,  // 31 WY  - L1C BOC(11)+BOC(61) for pilot channel
   SBAS_L1     :32,  // 32 SBAS L1 temporary place holder
   SBAS_L2     :33,  // 33 SBAS L2
   SBAS_L5     :34,  // 34 SBAS L5
   B1I         :35,  // 35 BeiDou B1I
   B2I         :36,  // 36 BeiDou B2I
   QZSS_CA_L1  :37,  // 37 QZSS L1 CA
   QZSS_L1CD   :38,  // 38 QZSS L1CD
   QZSS_L1CP   :39,  // 39 QZSS L1CP
   QZSS_L2CM   :40,  // 40 QZSS l2CM
   QZSS_L2CL   :41,  // 41 QZSS l2CL
   QZSS_L5I    :42,  // 42 QZSS L5I
   QZSS_L5Q    :43,  // 43 QZSS L5Q
   QZSS_L1_SAIF:44,  // 44 QZSS SAIF
   LEGACY_P1   :45,  // 45 (NOVA P1)
   QZSS_LEX    :46   // 46 QZSS LEX
};

var trackingsV1 =
{
   V1_IDLE            :0,  // Channel is disabled (OFF)
   V1_INVALID_START   :1,  // The requested start was invalid or too far in future
   V1_SIGDET_FAIL     :2,  // Signal detection fail
   V1_FREQ_VERIFY_FAIL:3,  // Frequency Verify fail
   V1_BIT_SYNC_FAIL   :4,  // Bit synchronization failed.
   V1_WAIT_TO_START   :5,  // Waiting for ASIC channel to start
   V1_STARTING        :6,  // Start command written to ASIC wait for CT to start
   V1_STARTED         :7,  // Channel starting
   V1_MOVECH_START    :8,  // Coherent Move channel Start-up
   V1_HANDOVER_START  :9,  // Coherent Handover Start-up 
   V1_NCH_SIGDET_PROC :10, // Non-coherent Signal detection
   V1_SIGDET_RESUME   :11, // Resume signal detection from Frequency Verify
   V1_COH_SIGDET_PROC :12, // Coherent Signal detection
   V1_FREQ_VERIFY     :13, // Verify detection frequency               
   V1_Y_P_PULL_IN     :14, // Pull-in of only PxP coders in Y mode
   V1_Y_Y_PULL_IN     :15, // Pull-in of PxY code and phase in Y mode
   V1_AFC_INIT_PROC   :16, // First cycle of AFC processing
   V1_AFC_PROC        :17, // AFC processing
   V1_AFC_COSTAS_PROC :18, // AFC + Costas processing
   V1_NCH_COSTAS_PROC :19, // Non-coherent Costas Loop
   V1_BIT_SYNC_PROC   :20, // Bit synchronization in progress
   V1_FRAME_SYNC_PROC :21, // Frame synchronization in progress
   V1_COSTAS_PROC     :22, // Coherent Costas pull-in after synchronous start
   V1_W_CODE          :23, // w code tracking pull in
   V1_CA_LOCKED       :24, // Locked up for C/A satellites measurements ready
   V1_COH_Y_TRACK     :25, // Coherent Y Tracking measurements ready
   V1_NOISE_TRACK     :26  // Dedicated noise tracking only state
};

var trackingsV3 =
{
   V3_IDLE            :0,  // Channel is disabled (OFF)
   V3_INVALID_START   :1,  // The requested start was invalid or too far in future
   V3_SIGDET_FAIL     :2,  // Signal detection fail
   V3_FREQ_VERIFY_FAIL:3,  // Frequency Verify fail
   V3_BIT_SYNC_FAIL   :4,  // Bit synchronization failed.
   V3_WAIT_TO_START   :5,  // Waiting for ASIC channel to start
   V3_STARTING        :6,  // Start command written to ASIC wait for CT to start
   V3_STARTED         :7,  // Channel starting
   V3_HANDOVER_WAIT   :8,  //Coherent Move channel Start-up
   V3_SYNC_TRANS_WAIT :9,  //Wait till a new PR latch to compute the start time
   //sphinx
   V3_MOVECH_START    :10, //Coherent Move channel Start-up
   V3_HANDOVER_START  :11, // Wait till a new PR latch to compute the start time
   //s-
   V3_NCH_SIGDET_PROC :12, // Non-coherent Signal detection
   V3_SIGDET_RESUME   :13, // Resume signal detection from Frequency Verify
   V3_COH_SIGDET_PROC :14, // Coherent Signal detection
   V3_FREQ_VERIFY     :15, // Verify detection frequency               
   V3_Y_P_PULL_IN     :16, // Pull-in of only PxP coders in Y mode
   V3_Y_Y_PULL_IN     :17, // Pull-in of PxY code and phase in Y mode
   V3_AFC_INIT_PROC   :18, // First cycle of AFC processing
   V3_AFC_PROC        :19, // AFC processing
   V3_AFC_COSTAS_PROC :20, // AFC + Costas processing
   V3_NCH_COSTAS_PROC :21, // Non-coherent Costas Loop
   V3_BIT_SYNC_PROC   :22, // Bit synchronization in progress
   V3_FRAME_SYNC_PROC :23, // Frame synchronization in progress
   V3_COSTAS_PROC     :24, // Coherent Costas pull-in after synchronous start
   V3_FIRST_LOCK      :25, // w code tracking pull in
   V3_CA_LOCKED       :26, // Locked up for C/A satellites measurements ready
   V3_COH_Y_TRACK     :27, // Coherent Y Tracking measurements ready
   V3_NOISE_TRACK     :28  // Dedicated noise tracking only state
};

var trackingStrV1 = 
[   
   "IDLE",
   "INVD",
   "SGDF",
   "FRQF",
   "BTSF",
   "WAIT",
   "STRT",
   "STRD",
   "MOVE",
   "HAND",
   "NCHS",
   "SGDR",
   "COHS",
   "FREQ",
   "YPIN",
   "YYIN",
   "AFCI",
   "AFCP",
   "AFCC",
   "NCHC",
   "BTSP",
   "FRMS",
   "CSTS",
   "WCDE",
   "LOCK",
   "COHY",
   "NOIS"
];

var trackingStrV3 =
[
   "IDLE",
   "INVD",
   "SGDF",
   "FRQF",
   "BTSF",
   "WAIT",
   "STRT",
   "STRD",
   "HNDW",
   "SYTW",
   "MOVE",
   "HAND",
   "NCHS",
   "SGDR",
   "COHS",
   "FREQ",
   "YPIN",
   "YYIN",
   "AFCI",
   "AFCP",
   "AFCC",
   "NCHC",
   "BTSP",
   "FRMS",
   "CSTS",
   "WCDE",
   "LOCK",
   "COHY",
   "NOIS"
];

function ISGPS(id)       { return (id >= 1) && (id <= 37); }
function ISGLONASS(id)   { return (id >= 38) && (id <= 61); }
function ISGALILEO(id)   { return (id >= 62) && (id <= 97); }
function ISSBAS(id)      { return (id >= 120) && (id <= 138); }
function ISBEIDOU(id)    { return (id >= 139) && (id <= 168); }
function getSatType(prn)
{
   if(ISGPS(prn))
      return "GPS";
   else if(ISGLONASS(prn))
      return "GLONASS";
   else if(ISGALILEO(prn))
      return "GALILEO";
   else if(ISSBAS(prn))
      return "SBAS";
   else if (ISBEIDOU(prn))
      return "BEIDOU";
   else
      return "UNKNOWN";
}
function chnlstatus1b_obj()
{
   var MsgName = "[CHNLSTATUS1B]"

   this.update = function (input) 
   {
      var start = input.indexOf(MsgName);

      //don't start parsing if this is not the right message
      if (start < 0) 
      {
         return false;
      }
      this.name = MsgName;

      //init the parser
      var p = new parser(input, start + MsgName.length);

      //get the pvt1b info
      this.length = p.fetchU16();
      this.week = p.fetchU16();
      this.TOWms = p.fetchU32();
      this.TOW = this.TOWms / 1000;

      this.ver = p.fetchU04();
      this.conf = p.fetchU04();

      tmp = p.fetchU08();
      this.coopTrack = (tmp >> 7) & 0x01;
      this.sfcn0 = (tmp & 0x3F);

      this.sfState = p.fetchU08();
      this.sfSatID = p.fetchU32();

      tmp = p.fetchU08();
      this.startType = (tmp >> 6) & 0x03;
      this.satsVisible = (tmp & 0x3F);

      tmp = p.fetchU08();
      this.posStat = (tmp >> 6) & 0x03;
      this.satsTracked = (tmp & 0x3F);

      tmp = p.fetchU08();
      this.almAvailable = (tmp >> 7) & 0x01;
      this.satsInMsg = (tmp & 0x3F);

      this.sats = [];

      if (this.satsInMsg > 0) 
      {
         for (i = 0; i < this.satsInMsg; i++) 
         {

            this.sats[i] = new Sat;

            this.sats[i].prn = p.fetchU08();
            this.sats[i].satType = getSatType(this.sats[i].prn);


            num_ch_block = p.fetchU08();
            azel = p.fetchU16();
            this.sats[i].az = (azel >> 7) & 0x1FF;
            this.sats[i].el = (azel & 0x7F);

            for (j = 0; j < num_ch_block; j++) 
            {
               this.sats[i].chnl[j] = new Chnl();
               ch = p.fetchU08();
               ct_am = p.fetchU08();
               ts_lb = p.fetchU08();
               cn0 = p.fetchU08();
               cr = p.fetchU08();
               st_mm = p.fetchU08();

                   this.sats[i].chnl[j].ch = ch;
                   this.sats[i].chnl[j].ct = (ct_am >> 2) & 0x3F;
                   this.sats[i].chnl[j].am = ct_am & 0x03;
                   this.sats[i].chnl[j].ts = (ts_lb >> 3) & 0x1F;
                   this.sats[i].chnl[j].lb = ts_lb & 0x07;
                   this.sats[i].chnl[j].cn0 = cn0;
                   this.sats[i].chnl[j].cr = cr;
                   this.sats[i].chnl[j].st = (st_mm >> 2) & 0x3F;
                   this.sats[i].chnl[j].mm = st_mm & 0x03;

               //is the P Code valid?
               this.sats[i].chnl[j].isP1 = ((this.sats[i].chnl[j].ct & 0x80) != 0);

               if (this.ver <= 2) 
               {
                  if (this.sats[i].chnl[j].ts >= 0 && this.sats[i].chnl[j].ts < trackingStrV1.length)
                  {
                     this.sats[i].chnl[j].trackingStrV1 = trackingStrV1[this.sats[i].chnl[j].ts];
                  }       
                  else
                  {
                     this.sats[i].chnl[j].trackingStrV1 = "NA";
                  }
               }
               else if (this.ver >= 3) 
               {
                  if (this.sats[i].chnl[j].ts >= 0 && this.sats[i].chnl[j].ts < trackingStrV3.length)
                  {
                     this.sats[i].chnl[j].trackingStrV3 = trackingStrV3[this.sats[i].chnl[j].ts];
                  }
                  else
                  {
                     this.sats[i].chnl[j].trackingStrV3 = "NA";
                  }
               }

               var idx = -1;
               var codeType = this.sats[i].chnl[j].ct & 0x7F;
               if (getSatType(this.sats[i].prn) == "GPS") 
               {
                  switch (codeType) 
                  {
                     case XCODE.CW_L1: break;
                     case XCODE.CW_L2: break;
                     case XCODE.CW_L5: idx = GPSIDX.L5; break;
                     case XCODE.CA_L1: idx = GPSIDX.L1CA; break;
                     case XCODE.CA_L2: break;
                     case XCODE.L2CM: idx = GPSIDX.L2C; break;
                     case XCODE.L2CL: idx = GPSIDX.L2C; break;
                     case XCODE.L5I: idx = GPSIDX.L5; break;
                     case XCODE.L5Q: idx = GPSIDX.L5; break;
                     case XCODE.MEM_CODE_4: break;
                     case XCODE.MEM_CODE_5: break;
                     case XCODE.P_L1: idx = GPSIDX.L1P1; break;
                     case XCODE.P_L2: idx = GPSIDX.L2; break;
                     case XCODE.Y_L1:
                        if (this.sats[i].chnl[j].isP1) 
                        {
                           idx = GPSIDX.L1P1;
                        }
                        else 
                        {
                           idx = GPSIDX.L1CA;
                        }
                        break;
                     case XCODE.LEGACY_P1: idx = GPSIDX.L1P1; break;
                     case XCODE.Y_L2Acq: idx = GPSIDX.L2; break;
                     case XCODE.Y_L1Acq: idx = GPSIDX.L1P1; break;
                     case XCODE.Y_L2Trk: idx = GPSIDX.L2; break;
                     case XCODE.Y_L1Trk: idx = GPSIDX.L1P1; break;
                     //sphinx   
                     case XCODE.L1CD: break;
                     case XCODE.L1CP: break;
                     default: break;
                  }
               }
               else if (getSatType(this.sats[i].prn) == "GLONASS") 
               {
                  switch (codeType) 
                  {
                     case XCODE.G1C: idx = GLNIDX.G1C; break;
                     case XCODE.G2C: idx = GLNIDX.G2C; break;
                     case XCODE.G1P: idx = GLNIDX.G1P; break;
                     case XCODE.G2P: idx = GLNIDX.G2P; break;
                     default: break;
                  }
               }
               else if (getSatType(this.sats[i].prn) == "GALILEO") 
               {
                  switch (codeType) 
                  {
                     case XCODE.E5AI: idx = GALIDX.E1B; break;
                     case XCODE.E5AQ: idx = GALIDX.E5AQ; break;
                     case XCODE.E5BI: break;
                     case XCODE.E5BQ: idx = GALIDX.E5BQ; break;
                     case XCODE.E1B: idx = GALIDX.E1B; break;
                     case XCODE.E1C: break;
                     case XCODE.E6B: break;
                     case XCODE.E6C: break;
                     default: break;
                  }
               }
               else if (getSatType(this.sats[i].prn) == "SBAS") 
               {
                  switch (codeType) 
                  {
                     case XCODE.CW_L1: break;
                     case XCODE.CW_L2: break;
                     case XCODE.CW_L5: idx = SBASIDX.L5; break;
                     case XCODE.CA_L1: idx = SBASIDX.L1CA; break;
                     case XCODE.CA_L2: break;
                     case XCODE.L2CM: idx = SBASIDX.L2C; break;
                     case XCODE.L2CL: idx = SBASIDX.L2C; break;
                     case XCODE.L5I: idx = SBASIDX.L5; break;
                     case XCODE.L5Q: idx = SBASIDX.L5; break;
                     case XCODE.MEM_CODE_4: break;
                     case XCODE.MEM_CODE_5: break;
                     case XCODE.P_L1: idx = SBASIDX.L1P1; break;
                     case XCODE.P_L2: idx = SBASIDX.L2; break;
                     case XCODE.Y_L1:
                        if (this.sats[i].chnl[j].isP1)
                        {
                           idx = SBASIDX.L1P1;
                        }
                        else
                        {
                           idx = SBASIDX.L1CA;
                        }
                        break;
                     case XCODE.LEGACY_P1: idx = SBASIDX.L1P1; break;
                     case XCODE.Y_L2Acq: idx = SBASIDX.L2; break;
                     case XCODE.Y_L1Acq: idx = SBASIDX.L1P1; break;
                     case XCODE.Y_L2Trk: idx = SBASIDX.L2; break;
                     case XCODE.Y_L1Trk: idx = SBASIDX.L1P1; break;
                     case XCODE.E5AI: break;
                     case XCODE.E5AQ: break;
                     case XCODE.E5BI: break;
                     case XCODE.E5BQ: break;
                     case XCODE.E1B: break;
                     case XCODE.E1C: break;
                     case XCODE.E6B: break;
                     case XCODE.E6C: break;
                     case XCODE.G1C: break;
                     case XCODE.G2C: break;
                     case XCODE.G1P: break;
                     case XCODE.G2P: break;
                     //sphinx   
                     case XCODE.L1CD: break;
                     case XCODE.L1CP: break;
                     default: break;
                  }
                  if (this.ver >= 3) 
                  {
                     switch (codeType) 
                     {
                        case XCODE.SBAS_L1: idx = SBASIDX.L1CA; break;
                        case XCODE.SBAS_L2: idx = SBASIDX.L2; break;
                        case XCODE.SBAS_L5: idx = SBASIDX.L5; break;
                        default: break;
                     }
                  }
               }
               else if (getSatType(this.sats[i].prn) == "BEIDOU") 
               {
                  switch (codeType) 
                  {
                     case XCODE.B1I: idx = BEIIDX.B1I; break;
                     case XCODE.B2I: idx = BEIIDX.B2I; break;
                     default: break;
                  }
               }

               this.sats[i].chnl[j].idx = idx;
            }
         }
      }

      return true;
   }
}