function sfstatus1b_record() {
    this.channel_num;
    this.satellite_id;
    this.indicator;
    this.signal_status;
    this.signal_strength;
    this.agc_voltage;
    this.good_percentage;
    this.idle_percentage;
    this.resync_count;
    this.freq_offset;
    this.license_status;
    this.SF20HubID;
    this.SF25HubID;
    this.HubIDValid;
    this.channel_step;
}

function sfstatus1b_obj()
{
   var MsgName = "[SFSTATUS1B]"

   this.update = function (input) 
   {
      var start = input.indexOf(MsgName);

      //don't start parsing if this is not the right message
      if (start < 0) 
      {
         return false;
      }
      this.name = MsgName;

      //init the parser
      var p = new parser(input, start + MsgName.length);

      //get the sfstatus1b info
      this.length = p.fetchU16();
      this.week = p.fetchU16();
      this.TOWms = p.fetchU32();
      this.ver = p.fetchU04();
      this.conf = p.fetchU04();

      this.block_count = p.fetchU08();
      this.channelBlock = [];

      for (count = 0; count < this.block_count; count++) 
      {
         this.channelBlock[count] = new sfstatus1b_record;

         this.channelBlock[count].satellite_id = 0;

         chno = p.fetchU32();
         chnum = chno & 0x1FFFFF;           
         this.channelBlock[count].channel_num = chno & 0x1FFFFF;
         if (chnum <= 70000) 
         {
            this.channelBlock[count].channel_num = chnum;
         }
         else 
         {
            this.channelBlock[count].channel_num = "Invalid Channel Number";
         }

         this.channelBlock[count].indicator = p.fetchU08();
         switch (this.channelBlock[count].indicator) 
         {
            case 1:
               this.channelBlock[count].indicator = "98W Laurentides";
               break;
            case 2:
               this.channelBlock[count].indicator = "25E Burum";
               break;
            case 3:
               this.channelBlock[count].indicator = "143.5E Auckland";
               break;
            case 4:
               this.channelBlock[count].indicator = "178E Santa Paula, CA";
               break;
            case 5:
               this.channelBlock[count].indicator = "54W Southbury";
               break;
            case 6:
               this.channelBlock[count].indicator = "64E Perth";
               break;
            case 9:
               this.channelBlock[count].indicator = "Manual Override";
               break;
            default:
               this.channelBlock[count].indicator = "Unknown";
               break;
         }

         this.channelBlock[count].signal_status = p.fetchU08();
         switch (this.channelBlock[count].signal_status) 
         {
            case 0:
               this.channelBlock[count].signal_status = "PWON";
               break;
            case 1:
               this.channelBlock[count].signal_status = "IDLE";
               break;
            case 2:
               this.channelBlock[count].signal_status = "WAIT";
               break;
            case 3:
               this.channelBlock[count].signal_status = "STRT";
               break;
            case 4:
               this.channelBlock[count].signal_status = "SGDP";
               break;
            case 5:
               this.channelBlock[count].signal_status = "SGDF";
               break;
            case 6:
               this.channelBlock[count].signal_status = "FREQ";
               break;
            case 7:
               this.channelBlock[count].signal_status = "ACQ";
               break;
            case 8:
               this.channelBlock[count].signal_status = "PLIN";
               break;
            case 9:
               this.channelBlock[count].signal_status = "TRCK";
               break;
            case 10:
               this.channelBlock[count].signal_status = "VFFT";
               break;
            default:
               this.channelBlock[count].signal_status = "Unknown";
               break;
         }

         this.channelBlock[count].signal_strength = p.fetchR32() / 4.0;
         this.channelBlock[count].agc_voltage = p.fetchR32();
         this.channelBlock[count].good_percentage = p.fetchR32();
         this.channelBlock[count].idle_percentage = p.fetchR32();
         this.channelBlock[count].resync_count = p.fetchU32();
         this.channelBlock[count].freq_offset = p.fetchR32();
         license = p.fetchU08();
         this.channelBlock[count].license_status = license & 0x01;
         this.channelBlock[count].hub_id_20 = (license >> 2) & 0x07;
         this.channelBlock[count].hub_id_25 = (license >> 5) & 0x07;
         this.channelBlock[count].HubIdvalid = (0x01 == (license & 0x01)) ? "Valid" : "Invalid";
         this.channelBlock[count].channel_step = p.fetchU32();
     }
     this.sfbeamindicator = p.fetchU08();
     this.exthubid = p.fetchU08();

      return true;
   }
}